代码随想录算法训练营第23天 | 39.组合总和、40.组合总和Ⅱ、131.分割回文串

代码随想录算法训练营第23天 | 39.组合总和、40.组合总和Ⅱ、131.分割回文串


39.组合总和

题目链接:39.组合总和

解题思路

本题和之前几题的区别在于没有数量要求,数字可以无限重复,但是有总和的限制,所以是有个数限制的。

使用回溯算法解题:

  • 递归函数的参数和返回值:两个全局变量,数组 path 存放符合条件的结果,二维数组 result 存放结果集;定义题目中给出的参数集合 candidate 和目标值 target;此外使用 sum 来记录单一 path 总和,另外还需要 startIndex 控制起始位置。
  • 终止条件:sum 大于等于 target
  • 确定单层递归逻辑:从 startIndex 开始搜索 cnadidate 集合。
代码实现
class Solution {
public:
    vector<int> path;
    vector<vector<int>> result;
    void backtracking(vector<int>& candidates, int target, int sum,
                      int startIndex) {
        if (sum > target) {
            return;
        }
        if (sum == target) {
            result.push_back(path);
            return;
        }

        for (int i = startIndex; i < candidates.size(); i++) {
            sum += candidates[i];
            path.push_back(candidates[i]);
            backtracking(candidates, target, sum, i);
            sum -= candidates[i];
            path.pop_back();
        }
    }

    vector<vector<int>> combinationSum(vector<int>& candidates, int target) {
        result.clear();
        path.clear();
        backtracking(candidates,target,0,0);
        return result;
    }
};
题目总结

对于组合问题,什么时候需要使用 startIndex?

如果是在一个集合中求元素组合,需要 startIndex,若是在多个集合中求元素组合,各个集合之间相互不影响,那么就不需要 startIndex。

40.组合总和Ⅱ

题目链接:40组合总和Ⅱ

解题思路

本题和上一题的区别就在于 candidates 中的数字在每个组合中只能使用一次,并且本题中的 candidates 内有重复的元素,这就需要去重操作。

  • 递归函数的参数和返回值:本题增加一个 bool 类型的数组 used 用来记录同一个树枝上的元素是否使用过,其他参数和上题一样
  • 终止条件:与上题相同。
  • 单层递归的逻辑:这里需要注意去重的操作:若 candidate[i] = candidate[i-1] 且 used[i-1] = false,说明前一个树枝使用了 candidate[i-1],此时 for 循环内执行 continue。
代码实现
class Solution {
public:
    vector<vector<int>> result;
    vector<int> path;
    void backtracking(vector<int>& candidates, int target, int sum,
                      int startIndex, vector<bool>& used) {
        if (sum == target) {
            result.push_back(path);
            return;
        }

        for (int i = startIndex;
             i < candidates.size() && sum + candidates[i] <= target; i++) {
            if (i > 0 && candidates[i] == candidates[i - 1] &&
                used[i - 1] == false) {
                continue;
            }
            sum += candidates[i];
            path.push_back(candidates[i]);
            used[i] = true;
            backtracking(candidates, target, sum, i + 1, used);
            used[i] = false;
            sum -= candidates[i];
            path.pop_back();
        }
    }

    vector<vector<int>> combinationSum2(vector<int>& candidates, int target) {
        vector<bool> used(candidates.size(), false);
        result.clear();
        path.clear();
        sort(candidates.begin(), candidates.end());
        backtracking(candidates, target, 0, 0, used);
        return result;
    }
};
题目总结

理解数层去重和树枝去重这两个维度。

131.分割回文串

题目链接:131.分割回文串

解题思路

本题中主要涉及两个问题:有多少种不同的切割方式和判断回文

  • 递归函数参数和返回值:两个数组存放结果,此外还需要 startIndex
  • 终止条件:切割线切割到了字符串最后面,说明找到了一种切割方案
  • 单层递归的逻辑:判断回文子串可以用双指针法,一个指针从前往后遍历,另一个从后向前遍历,若前后指针指向的元素相等,那么该字符串就是回文子串。
代码实现
class Solution {
public:
    vector<vector<string>> result;
    vector<string> path;
    void backtracking(const string& s, int startIndex) {
        if (startIndex >= s.size()) {
            result.push_back(path);
            return;
        }

        for (int i = startIndex; i < s.size(); i++) {
            if (isPalindrome(s, startIndex, i)) {
                string str = s.substr(startIndex, i - startIndex + 1);
                path.push_back(str);
            } else {
                continue;
            }
            backtracking(s, i + 1);
            path.pop_back();
        }
    }

    bool isPalindrome(const string& s, int start, int end) {
        for (int i = start, j = end; i < j; i++, j--) {
            if (s[i] != s[j]) {
                return false;
            }
        }
        return true;
    }

    vector<vector<string>> partition(string s) {
        result.clear();
        path.clear();
        backtracking(s, 0);
        return result;
    }
};
题目总结

本题将切割问题抽象为了组合问题

  • 2
    点赞
  • 3
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
第二十二算法训练营主要涵盖了Leetcode题目中的三道题目,分别是Leetcode 28 "Find the Index of the First Occurrence in a String",Leetcode 977 "有序数组的平方",和Leetcode 209 "长度最小的子数组"。 首先是Leetcode 28题,题目要求在给定的字符串中找到第一个出现的字符的索引。思路是使用双指针来遍历字符串,一个指向字符串的开头,另一个指向字符串的结尾。通过比较两个指针所指向的字符是否相等来判断是否找到了第一个出现的字符。具体实现的代码如下: ```python def findIndex(self, s: str) -> int: left = 0 right = len(s) - 1 while left <= right: if s[left == s[right]: return left left += 1 right -= 1 return -1 ``` 接下来是Leetcode 977题,题目要求对给定的有序数组中的元素进行平方,并按照非递减的顺序返回结果。这里由于数组已经是有序的,所以可以使用双指针的方法来解决问题。一个指针指向数组的开头,另一个指针指向数组的末尾。通过比较两个指针所指向的元素的绝对值的大小来确定哪个元素的平方应该放在结果数组的末尾。具体实现的代码如下: ```python def sortedSquares(self, nums: List[int]) -> List[int]: left = 0 right = len(nums) - 1 ans = [] while left <= right: if abs(nums[left]) >= abs(nums[right]): ans.append(nums[left ** 2) left += 1 else: ans.append(nums[right ** 2) right -= 1 return ans[::-1] ``` 最后是Leetcode 209题,题目要求在给定的数组中找到长度最小的子数组,使得子数组的和大于等于给定的目标值。这里可以使用滑动窗口的方法来解决问题。使用两个指针来表示滑动窗口的左边界和右边界,通过移动指针来调整滑动窗口的大小,使得滑动窗口中的元素的和满足题目要求。具体实现的代码如下: ```python def minSubArrayLen(self, target: int, nums: List[int]) -> int: left = 0 right = 0 ans = float(&#39;inf&#39;) total = 0 while right < len(nums): total += nums[right] while total >= target: ans = min(ans, right - left + 1) total -= nums[left] left += 1 right += 1 return ans if ans != float(&#39;inf&#39;) else 0 ``` 以上就是第二十二算法训练营的内容。通过这些题目的练习,可以提升对双指针和滑动窗口等算法的理解和应用能力。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值